import { PureComponent } from 'react';
import { FormValidationRule } from './FormValidationRule';
export declare type FormValidationRenderFn = (props: FormValidationRenderProps) => React.ReactChild;
export declare type OnValidatedFn = (isValid: boolean, validationErrors: IValidationErrors) => void;
export declare type ValidateFn = (data?: any) => void;
export interface IValidationErrors {
    [field: string]: string[];
}
export interface FormValidationRenderProps {
    validationErrors: IValidationErrors;
    isValid: boolean;
    validate: ValidateFn;
}
export interface IFormValidationProps {
    children: FormValidationRenderFn;
    data?: any;
    validateOnMount?: boolean;
    onValidated?: OnValidatedFn;
    validations: FormValidationRule[];
}
interface IFormValidationState {
    isValid: boolean;
    validationErrors: IValidationErrors;
    validating: boolean;
}
export declare class FormValidation extends PureComponent<IFormValidationProps, IFormValidationState> {
    state: {
        isValid: boolean;
        validationErrors: {};
        validating: boolean;
    };
    static defaultProps: {
        validateOnMount: boolean;
    };
    componentDidMount(): void;
    onValidate: ((data: any) => Promise<void>) & import("lodash").Cancelable;
    render(): import("react").ReactChild;
}
export {};
//# sourceMappingURL=FormValidation.d.ts.map