"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var debounce_1 = __importDefault(require("lodash/debounce"));
var react_1 = require("react");
var validator_1 = __importDefault(require("validator"));
function getValue(data, field) {
    if (!data || !field) {
        return undefined;
    }
    return field.split('.').reduce(function (result, prop) {
        if (!result || !prop) {
            return undefined;
        }
        return result[prop];
    }, data);
}
var FormValidation = /** @class */ (function (_super) {
    __extends(FormValidation, _super);
    function FormValidation() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isValid: false,
            validationErrors: {},
            validating: false
        };
        _this.onValidate = debounce_1.default(function (data) { return __awaiter(_this, void 0, void 0, function () {
            var validationErrors, i, rule, testFn, value, args, validWhen, testResult, err_1, isValid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!Array.isArray(this.props.validations) || this.props.validations.length === 0) {
                            this.setState({
                                validationErrors: {},
                                isValid: true,
                                validating: false
                            });
                        }
                        this.setState({ validating: true });
                        data = data || this.props.data;
                        validationErrors = {};
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this.props.validations.length)) return [3 /*break*/, 7];
                        rule = this.props.validations[i];
                        testFn = typeof rule.test === 'string' ? validator_1.default[rule.test] : rule.test;
                        if (!(typeof testFn === 'function')) return [3 /*break*/, 6];
                        value = getValue(data, rule.field);
                        args = rule.args || [];
                        validWhen = rule.validWhen || false;
                        testResult = void 0;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 4, , 5]);
                        return [4 /*yield*/, testFn.apply(void 0, [value].concat(args))];
                    case 3:
                        testResult = _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        err_1 = _a.sent();
                        testResult = undefined;
                        return [3 /*break*/, 5];
                    case 5:
                        if (testResult !== validWhen) {
                            if (!Array.isArray(validationErrors[rule.field])) {
                                validationErrors[rule.field] = [rule.message];
                            }
                            else {
                                validationErrors[rule.field].push(rule.message);
                            }
                        }
                        _a.label = 6;
                    case 6:
                        i++;
                        return [3 /*break*/, 1];
                    case 7:
                        isValid = Object.keys(validationErrors).length === 0;
                        this.setState({
                            isValid: isValid,
                            validationErrors: validationErrors,
                            validating: false
                        });
                        if (this.props.onValidated) {
                            this.props.onValidated(isValid, validationErrors);
                        }
                        return [2 /*return*/];
                }
            });
        }); }, 300);
        return _this;
    }
    FormValidation.prototype.componentDidMount = function () {
        if (this.props.data && this.props.validateOnMount) {
            this.onValidate(this.props.data);
        }
    };
    FormValidation.prototype.render = function () {
        return this.props.children({
            validationErrors: this.state.validationErrors,
            isValid: this.state.isValid,
            validate: this.onValidate
        });
    };
    FormValidation.defaultProps = {
        validateOnMount: true
    };
    return FormValidation;
}(react_1.PureComponent));
exports.FormValidation = FormValidation;
//# sourceMappingURL=FormValidation.js.map